unit EncSelFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Transformation;

type
  TEncSelForm = class(TForm)
    GroupBox1: TGroupBox;
    ModList: TListBox;
    Label1: TLabel;
    ModVerLab: TLabel;
    Label2: TLabel;
    AuthorMemo: TMemo;
    Label3: TLabel;
    ModDescMemo: TMemo;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    TransVerLab: TLabel;
    Label7: TLabel;
    TransList: TListBox;
    TransDescMemo: TMemo;
    Label5: TLabel;
    ModCodeLab: TLabel;
    TransCodeLab: TLabel;
    Label9: TLabel;
    SelBtn: TButton;
    Button2: TButton;
    ReloadBtn: TButton;
    ConfBtn: TButton;
    Button1: TButton;
    ForceDefModule: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ModListClick(Sender: TObject);
    procedure TransListClick(Sender: TObject);
    procedure SelBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ReloadBtnClick(Sender: TObject);
    procedure TransListDblClick(Sender: TObject);
    procedure ConfBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    iSelModule, iSelTrans : longword;
    iTransName : string;
    iDefModule, iDefTrans : longword;
    procedure UpdateModList;
  public
    property SelModule : longword read iSelModule;
    property SelTrans : longword read iSelTrans;
    property DefModule : longword read iDefModule;
    property DefTrans : longword read iDefTrans;
    property TransName : string read iTransName;
    { Public declarations }
  end;

var
  EncSelForm: TEncSelForm;


function FindTransformation(modID:longword; transID:longword):PTransformation; cdecl;


implementation
uses InternalModule;
{$R *.DFM}


function FindTransformation(modID:longword; transID:longword):PTransformation;
var i,j:integer;
    MH:PModuleHeader;
    T:PTransformation;
begin
  Result:=nil;
  with EncSelForm do begin
    i:=0;
    while (i<ModList.Items.Count) and (Result=nil) do begin
      MH:=pointer(ModList.Items.Objects[i]);
      if (modID=0) or (MH.ID=modID) then begin
        j:=0; T:=MH.GetTransformation(j);
        while (T<>nil) and (Result=nil) do begin
          if T.ID=transID then begin
            Result:=T;
            EncSelForm.iSelTrans:=transID;
            EncSelForm.iSelModule:=modID;
            EncSelForm.iTransName:=T.Name;
            EncSelForm.ModList.ItemIndex:=i;
            EncSelForm.ModList.OnClick(EncSelForm.ModList);
            EncSelForm.TransList.ItemIndex:=j;
            EncSelForm.TransList.OnClick(EncSelForm.TransList);
          end;
          inc(j);
          T:=MH.GetTransformation(j);
        end;
      end;
      inc(i);
    end;
  end;
  //if codec not found, try find same codec from other module
  if (Result=nil) and (modID<>0) then Result:=FindTransformation(0,transID);
end;


procedure TEncSelForm.UpdateModList;
var
  MH : PModuleHeader;
  SR : TSearchRec;
  path:string;
  Handle : HINST;
  DLLProc : TGetModuleHeader;
begin
  MH:=InternalModule.GetModuleHeader;
  MH.FindTransformation:=FindTransformation;
  MH.AppVersion:=$100;
  ModList.Items.AddObject(MH.Name,pointer(MH));
  path:=ParamStr(0);
  while path[Length(path)]<>'\' do Delete(path,Length(path),1);
  if FindFirst(path+'tr_*.dll',faAnyFile,SR)=0 then
    repeat
      Handle:=LoadLibrary(SR.FindData.cFileName);
      DLLProc:=GetProcAddress(Handle,'GetModuleHeader');
      if @DLLProc<>nil then begin
        MH:=DLLProc;
        if MH.hdrVersion=$100 then begin
          MH.HANDLE:=Handle;
          MH.FindTransformation:=FindTransformation;
          MH.AppVersion:=$100;
          MH.Init;
          ModList.Items.AddObject(MH.Name,pointer(MH));
        end else FreeLibrary(Handle);
      end else FreeLibrary(Handle);
    until FindNext(SR)<>0;
  FindClose(SR);

  ModList.ItemIndex:=0; ModList.OnClick(self);
end;

procedure TEncSelForm.FormCreate(Sender: TObject);
begin
  iDefModule:=1; iDefTrans:=2;
  UpdateModList;
end;

procedure TEncSelForm.ModListClick(Sender: TObject);
var
  MH : PModuleHeader;
  T : PTransformation;
  poms : string[15];
  i:integer;
begin
  MH:=pointer(ModList.Items.Objects[Modlist.ItemIndex]);
  str(MH.Version shr 8, poms);
  ModVerLab.Caption:=poms+'.';
  str(MH.Version and 255, poms);
  ModVerLab.Caption:=ModVerLab.Caption+poms;
  str(MH.ID,poms);
  ModCodeLab.Caption:=poms;
  ModDescMemo.Lines.Text:=MH.Description;
  AuthorMemo.Lines.Text:=MH.Author;
  TransList.Clear;
  i:=0; T:=MH.GetTransformation(i);
  while T<>nil do begin
    if T.public then
      if (T.ID=DefTrans) and (MH.ID=iDefModule) then TransList.Items.AddObject(T.Name+' [Default]',pointer(T))
      else TransList.Items.AddObject(T.Name,pointer(T));
    inc(i); T:=MH.GetTransformation(i);
  end;
  TransList.ItemIndex:=0; TransList.OnClick(self);
end;

procedure TEncSelForm.TransListClick(Sender: TObject);
var
  T : PTransformation;
  poms : string[15];
begin
  T:=pointer(TransList.Items.Objects[TransList.ItemIndex]);
  str(T.Version shr 8, poms);
  TransVerLab.Caption:=poms+'.';
  str(T.Version and 255, poms);
  TransVerLab.Caption:=TransVerLab.Caption+poms;
  str(T.ID,poms);
  TransCodeLab.Caption:=poms;
  TransDescMemo.Lines.Text:=T.Description;
  ConfBtn.Enabled:=@T.Configure<>nil;
end;

procedure TEncSelForm.SelBtnClick(Sender: TObject);
begin
  if (TransList.ItemIndex<0) or (ModList.ItemIndex<0) then begin
    MessageDlg('No transformation selected',mtError,[mbOK],0);
    exit;
  end;
  if (TransList.Items.Count=0) then begin
    iSelModule:=0;
    iSelTrans:=0;
    iTransName:='';
    exit;
  end;
  iSelModule:=PModuleHeader(ModList.Items.Objects[ModList.ItemIndex]).ID;
  iSelTrans:=PTransformation(TransList.Items.Objects[TransList.ItemIndex]).ID;
  iTransName:=PTransformation(TransList.Items.Objects[TransList.ItemIndex]).Name;
end;

procedure TEncSelForm.FormDestroy(Sender: TObject);
var
  MH : PModuleHeader;
begin
  while ModList.Items.Count>0 do begin
    MH:=pointer(ModList.Items.Objects[0]);
    MH.Finalize;
    FreeLibrary(MH.HANDLE);
    ModList.Items.Delete(0);
  end;
  TransList.Clear;
  ModVerLab.Caption:='';
  ModCodeLab.Caption:='';
  ModDescMemo.Lines.Text:='';
  AuthorMemo.Lines.Text:='';
  TransVerLab.Caption:='';
  TransCodeLab.Caption:='';
  TransDescMemo.Lines.Text:='';
end;

procedure TEncSelForm.ReloadBtnClick(Sender: TObject);
begin
  if ReloadBtn.Caption='&Flush Cache' then begin
    OnDestroy(self);
    ReloadBtn.Caption:='&Reload Modules'
  end else if ReloadBtn.Caption='&Reload Modules' then begin
    UpdateModList;
    ReloadBtn.Caption:='&Flush Cache'
  end;
end;

procedure TEncSelForm.TransListDblClick(Sender: TObject);
begin
  SelBtn.Click;
end;

procedure TEncSelForm.ConfBtnClick(Sender: TObject);
var
  T : PTransformation;
begin
  T:=pointer(TransList.Items.Objects[TransList.ItemIndex]);
  T.Configure;
end;

procedure TEncSelForm.Button1Click(Sender: TObject);
begin
  iDefModule:=PModuleHeader(ModList.Items.Objects[ModList.ItemIndex]).ID;
  iDefTrans:=PTransformation(TransList.Items.Objects[TransList.ItemIndex]).ID;
  ModList.OnClick(ModList);
end;

end.
