unit GenRect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TGenRectFrm = class(TForm)
    Label1: TLabel;
    XSizeSpin: TSpinEdit;
    Label2: TLabel;
    YSizeSpin: TSpinEdit;
    Label3: TLabel;
    XCountSpin: TSpinEdit;
    Label4: TLabel;
    YCountSpin: TSpinEdit;
    CancelBtn: TButton;
    GenBtn: TButton;
    procedure XSizeSpinChange(Sender: TObject);
    procedure YSizeSpinChange(Sender: TObject);
    procedure XCountSpinChange(Sender: TObject);
    procedure YCountSpinChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GenRectFrm: TGenRectFrm;

implementation

uses MainForm;

{$R *.DFM}

var Lock:byte;

procedure TGenRectFrm.XSizeSpinChange(Sender: TObject);
begin
  if TSpinEdit(Sender).Text='' then exit;
  if lock>0 then exit;
  inc(lock);
  if XSizeSpin.Value>0 then
    XCountSpin.Value:=(MainFrm.Picture.Picture.Bitmap.Width div XSizeSpin.Value)+1
  else XSizeSpin.Value:=0;
  dec(lock);
end;

procedure TGenRectFrm.YSizeSpinChange(Sender: TObject);
begin
  if TSpinEdit(Sender).Text='' then exit;
  if lock>0 then exit;
  inc(lock);
  if YSizeSpin.Value>0 then
    YCountSpin.Value:=(MainFrm.Picture.Picture.Bitmap.Height div YSizeSpin.Value)+1
  else YSizeSpin.Value:=0;
  dec(lock);
end;

procedure TGenRectFrm.XCountSpinChange(Sender: TObject);
begin
  if TSpinEdit(Sender).Text='' then exit;
  if lock>0 then exit;
  inc(lock);
  if XCountSpin.Value>0 then
    XSizeSpin.Value:=(MainFrm.Picture.Picture.Bitmap.Width div XCountSpin.Value)
  else XCountSpin.Value:=0;
  dec(lock);
end;

procedure TGenRectFrm.YCountSpinChange(Sender: TObject);
begin
  if TSpinEdit(Sender).Text='' then exit;
  if lock>0 then exit;
  inc(lock);
  if YCountSpin.Value>0 then
    YSizeSpin.Value:=(MainFrm.Picture.Picture.Bitmap.Height div YCountSpin.Value)
  else YCountSpin.Value:=0;
  dec(lock);
end;


begin
  lock:=0;
end.
